Automate release process (#1852)

This commit is contained in:
Vladimir Mihailenco 2021-08-11 17:14:46 +03:00 committed by GitHub
parent fd3025bfed
commit 5e89d627dd
No known key found for this signature in database
GPG Key ID: 4AEE18F83AFDEB23
4 changed files with 141 additions and 0 deletions

15
.github/workflows/release.yml vendored Normal file
View File

@ -0,0 +1,15 @@
name: release
on: push
jobs:
build:
runs-on: ubuntu-latest
steps:
- name: Checkout
uses: actions/checkout@v2
- name: Release
uses: softprops/action-gh-release@v1
if: startsWith(github.ref, 'refs/tags/')
with:
body: Check CHANGELOG.md for details

21
RELEASING.md Normal file
View File

@ -0,0 +1,21 @@
# Releasing
1. Run `release.sh` script which updates versions in go.mod files and pushes a new branch to GitHub:
```shell
./scripts/release.sh -t v1.0.0
```
2. Open a pull request and wait for the build to finish.
3. Merge the pull request and run `tag.sh` to create tags for packages:
```shell
./scripts/tag.sh -t v1.0.0
```
4. Push the tags:
```shell
git push origin --tags
```

65
scripts/release.sh Executable file
View File

@ -0,0 +1,65 @@
#!/bin/bash
set -e
help() {
cat <<- EOF
Usage: TAG=tag $0
Updates version in go.mod files and pushes a new brash to GitHub.
VARIABLES:
TAG git tag, for example, v1.0.0
EOF
exit 0
}
if [ -z "$TAG" ]
then
printf "TAG is required\n\n"
help
fi
TAG_REGEX="^v(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)(\\-[0-9A-Za-z-]+(\\.[0-9A-Za-z-]+)*)?(\\+[0-9A-Za-z-]+(\\.[0-9A-Za-z-]+)*)?$"
if ! [[ "${TAG}" =~ ${TAG_REGEX} ]]; then
printf "TAG is not valid: ${TAG}\n\n"
exit 1
fi
TAG_FOUND=`git tag --list ${TAG}`
if [[ ${TAG_FOUND} = ${TAG} ]] ; then
printf "tag ${TAG} already exists\n\n"
exit 1
fi
if ! git diff --quiet
then
printf "working tree is not clean\n\n"
git status
exit 1
fi
git checkout master
PACKAGE_DIRS=$(find . -mindepth 2 -type f -name 'go.mod' -exec dirname {} \; \
| sed 's/^\.\///' \
| sort)
for dir in $PACKAGE_DIRS
do
sed --in-place \
"s/uptrace\/bun\([^ ]*\) v.*/uptrace\/bun\1 ${TAG}/" "${dir}/go.mod"
done
for dir in $PACKAGE_DIRS
do
printf "${dir}: go mod tidy\n"
(cd ./${dir} && go mod tidy)
done
sed --in-place "s/\(return \)\"[^\"]*\"/\1\"${TAG#v}\"/" ./version.go
git checkout -b release/${TAG} master
git add -u
git commit -m "Release $TAG"
git push origin release/${TAG}

40
scripts/tag.sh Executable file
View File

@ -0,0 +1,40 @@
#!/bin/bash
set -e
help() {
cat <<- EOF
Usage: TAG=tag $0
Creates git tags for public Go packages.
VARIABLES:
TAG git tag, for example, v1.0.0
EOF
exit 0
}
if [ -z "$TAG" ]
then
printf "TAG env var is required\n\n";
help
fi
if ! grep -Fq "\"${TAG#v}\"" version.go
then
printf "version.go does not contain ${TAG#v}\n"
exit 1
fi
PACKAGE_DIRS=$(find . -mindepth 2 -type f -name 'go.mod' -exec dirname {} \; \
| grep -E -v "example|internal" \
| sed 's/^\.\///' \
| sort)
git tag ${TAG}
for dir in $PACKAGE_DIRS
do
printf "tagging ${dir}/${TAG}\n"
git tag ${dir}/${TAG}
done